/* --------------------------------------------------------
 Generated by Gunandi using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Gunandi (andri.gunandi1@gmail.com) 
 Date Created : 21/05/2019
 --------------------------------------------------------
*/
package com.portofolio.dao;

import  java.util.Map;

import  org.springframework.data.domain.Page;
import  org.springframework.data.domain.Pageable;
import  org.springframework.data.jpa.repository.JpaRepository;
import  org.springframework.data.jpa.repository.Query;
import  org.springframework.data.repository.query.Param;
import  org.springframework.stereotype.Repository;

import com.portofolio.entity.ProfileConfigDesign;
import com.portofolio.entity.vo.ProfileConfigDesignId;


@Repository("profileconfigdesignDao")
public interface ProfileConfigDesignDao extends JpaRepository<ProfileConfigDesign, ProfileConfigDesignId> {


    @Query(QListAll)
    Page<Map<String, Object>> findAllList( @Param("statusEnabled") boolean statusEnabled,Pageable page);
    
    @Query(QListAll + " and modulAplikasi.namaModulAplikasi like %:namaModulAplikasi% ")
    Page<Map<String, Object>> findAllList( @Param("namaModulAplikasi") String namaModulAplikasi,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    
    @Query(QListAll + "and id.kdVersion=:kdVersion and id.kdModulAplikasi=:kdModulAplikasi and profile.kode =:kdProfile")
	Map<String, Object> findById(@Param("kdProfile")Integer kdProfile, @Param("kdModulAplikasi") String kdModulAplikasi,@Param("kdVersion") Integer kdVersion,@Param("statusEnabled") boolean statusEnabled); 

    
    String QListAll ="select new map("
    		+ "  model.id.kdVersion as kdVersion"
    		+ ", model.id.kdModulAplikasi as kdModulAplikasi"
    		+ ", model.id.kdProfile as kdProfile "
            + ", model.kdBahasa as kdBahasa " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version "
            + ", profile.namaLengkap as namaLengkapProfile "
            + ", modulAplikasi.namaModulAplikasi as namaModulAplikasi "
            + ", bahasa.namaBahasa as namaBahasa "
            + ", versionSystem.namaVersion as namaVersion "
            + ")" 
            + " from ProfileConfigDesign model "
            + " left join model.id id "
            + " left join model.profile profile "
            + " left join Bahasa bahasa on bahasa.id.kdBahasa=model.kdBahasa "
            + " left join model.versionSystem as versionSystem"
            + " left join model.modulAplikasi modulAplikasi where model.statusEnabled=:statusEnabled ";

}
